#!/usr/bin/php -q
<?php
/* cli interface removal script */

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
} 
 
/* We are not talking to the browser */
$no_http_headers = true;

include(dirname(__FILE__)."/../include/global.php");
include_once($config["base_path"]."/lib/api_automation_tools.php");
include_once($config["base_path"]."/lib/utility.php");
include_once($config["base_path"]."/lib/api_data_source.php");
include_once($config["base_path"]."/lib/api_graph.php");
include_once($config["base_path"]."/lib/snmp.php");
include_once($config["base_path"]."/lib/data_query.php");
include_once($config["base_path"]."/lib/api_device.php");


/* process calling arguments*/
$parms = $_SERVER["argv"];
array_shift($parms);

if (!sizeof($parms)) {
	display_help();
	exit(0);
}
/* set up defaults*/
$hosts          = getHosts();
$quietMode      = FALSE;

foreach($parms as $parameter) {
	@list($arg, $value) = @explode("=", $parameter);
		
	switch ($arg) {
		case "--device-id":
			$prams['deviceid'] = trim($value);
			break;
		case "--list-devices":
			displayHosts($hosts, $quietMode);
			exit(0);
			break;
		case "--snmp-index":
			$prams['snmp_index'] = trim($value);
			break;
		case "--remove-diable":
			$prams['snmp_index'] = trim($value);
			if($value == "remove")
				$prams['remove_disable'] = $value;
			elseif($value == "disable")
				$prams['remove_disable'] = $value;
			else
				echo "--remove-diable must be set to [remove|disable]\n\n";
				exit(0);
			break;
		default:
			echo "ERROR: Missing or extraneous aruments.\n\n";
			display_help();
			exit(1);
	}

}


if(!isset($prams['snmp_index']) || !isset($prams['deviceid']) && !isset($prams['remove_disable']))
die("Please check for valid --device-id, --snmp-index and --remove-diable\n\n");



$graph_ids = db_fetch_assoc("SELECT id FROM graph_local WHERE snmp_index=".$prams['snmp_index']." AND host_id=".$prams['deviceid']);
if (sizeof($graph_ids) > 0) {
	foreach ($graph_ids as $rw) {
		
		if($prams['remove_disable'] == "remove"){
			api_graph_remove($rw['id']);
		}
		elseif($prams['remove_disable'] == "disable"){
			// need to ask cacti the comunity ? cant seem to find.
			echo "sorry disable is not an option at the moment.\n\n";
		}
	}
}



function display_help() {
	echo "Remove Interface Script 0.1 \n\n";
	echo "CLI utility to remove interface from Cacti\n\n";
	echo "Remove interface usage: remove_interface.php --device-id=[device id] --snmp-index=[snmp id]\n";
	echo "Required:\n";
	echo "    --device-id    host/device ID.\n\n";
	echo "    --snmp-index   snmp index / if index.\n\n";
	echo "List devices usage: remove_device.php --list-devices\n\n";
	echo "List Options:\n";
	echo "    --list-devices    Lists all devices\n\n";
}



